<?php
$Debug = $_REQUEST['debug'];
require 'include/common.php';
$PV = memcache_get($MemcacheObj, "alumni_pv_db");
memcache_set($MemcacheObj, "alumni_pv_db", ++$PV);
require 'include/events.php';
$HeaderFlag = FALSE;
if (isset($_REQUEST['do_register'])) {
    register(NULL, NULL, FALSE, $_REQUEST['newmail']);
} elseif (isset($_REQUEST['do_resend'])) {
    if (check_mail($_REQUEST['n'])) {
	resend($_REQUEST['n']);
    } else {
	bad_URL_page();
    }
} elseif (isset($_REQUEST['do_newname'])) {
    if (isset($Mail) && isset($Passwd)) {
	newname($Mail, $Passwd,
		$_REQUEST['newgraduate'],
		$_REQUEST['newname'], $_REQUEST['newkana']);
    } else {
	bad_URL_page();
    }
} elseif (isset($_REQUEST['do_delete'])) {
    if (isset($Mail) && isset($Passwd)) {
	delete($Mail, $Passwd);
    } else {
	bad_URL_page();
    }
} elseif (isset($_REQUEST['do_add'])) {
    if (isset($Mail) && isset($Passwd)) {
	register($Mail, $Passwd, FALSE, $_REQUEST['addmail']);
    } else {
	bad_URL_page();
    }
} elseif (isset($_REQUEST['do_modify'])) {
    if (isset($Mail) && isset($Passwd)) {
	register($Mail, $Passwd, TRUE, $_REQUEST['modmail']);
    } else {
	bad_URL_page();
    }
} elseif (isset($_REQUEST['do_correct'])) {
    if (isset($Mail) && isset($Passwd)) {
	correct($Mail, $Passwd, $_REQUEST['newgraduate'],
		$_REQUEST['newname'], $_REQUEST['newkana'],
		$_REQUEST['attend'], $_REQUEST['message']);
    } else {
	bad_URL_page();
    }
} elseif (isset($_REQUEST['do_list'])) {
    if (isset($Mail) && isset($Passwd)) {
	list_page($Mail, $Passwd, $_REQUEST['do_list']);
    } else {
	bad_URL_page();
    }
} else {
    if (isset($Mail) && isset($Passwd)) {
	user_page($Mail, $Passwd, '');
    } else {
	top_page('');
    }
}
page_header();
?>
<hr />
<p>
<a href="/">同窓会のページに戻る</a>
</p>
</body>
</html>

<?php
function register($oldmail, $oldpasswd, $del, $mail) {
    global $MyURL;
    if (isset($oldmail)) {
	if ($del) {
	    $action = 'do_modify';
	    $new = 'modmail';
	} else {
	    $action = 'do_add';
	    $new = 'addmail';
	}
	if ($oldpasswd === TRUE) {
	    $hidden = '';
	} else {
	    $hidden = '<input type="hidden" name="m" value="'
		. htmlspecialchars($oldmail, ENT_QUOTES) . '">' . "\n"
		. '<input type="hidden" name="p" value="'
		. htmlspecialchars($oldpasswd, ENT_QUOTES) . '">' . "\n";
	}
    } else {
	$action = 'do_register';
	$new = 'newmail';
	$hidden = '';
    }
    if (!check_mail($mail)) {
	page_header();
?>
<p>
<font color="red">
「<?php echo htmlspecialchars($mail, ENT_QUOTES); ?>」
はメールアドレスとして不適切です。
</font>
</p>
<p>
以下に正しいメールアドレスを入力して「送信」ボタンを押してください。
</p>
<p>
<form action="<?php echo $MyURL; ?>" method="post">
<?php echo $hidden; ?>
メールアドレス: <input type="text" name="<?php echo $new; ?>" size=20>
<input type="submit" name="<?php echo $action; ?>" value="送信">
</p>
<p>
入力頂いたメールアドレスにメールをお送りします。
メールが届きましたら、
メール本文中の URL へ WWWブラウザを使ってアクセスしてください。
</p>
</form>
<?php
	return;
    }
    $passwd = mkpasswd();
    $link = db_connect();
    if (!$link) {
	error_page("Could not connect to DB");
	return;
    }
    if (isset($oldmail)) {
	$query = "SELECT graduate, name, kana, message, events "
	. "FROM users WHERE "
	. "mail='" . mysql_escape_string($oldmail) . "'";
	if ($oldpasswd !== TRUE) {
	    $query .= " AND passwd='" . mysql_escape_string($oldpasswd) . "'";
	}
	$result = mysql_query($query, $link);
	if ($result === FALSE) {
	    $errno = mysql_errno($link);
	    $errmsg = mysql_error($link);
	    mysql_close($link);
	    error_page("err=" . $errno . " " . $errmsg
		       . " \nquery='$query'");
	    return;
	}
	unset($query);
	if ($line = mysql_fetch_row($result)) {
	    if (isset($line[0]) && ctype_digit($line[0])) {
		$graduate = $line[0];
	    } else {
		$graduate = "NULL";
	    }
	    $name = $line[1];
	    $kana = $line[2];
	    $message = $line[3];
	    $events = $line[4];
	    if ($del === TRUE) {
		$query = "DELETE FROM users WHERE "
		    . "mail='" . mysql_escape_string($oldmail) . "'";
		if ($oldpasswd !== TRUE) {
		    $query .= " AND passwd='"
			    . mysql_escape_string($oldpasswd) . "'";
		}
		$result = mysql_query($query, $link);
		if ($result === FALSE) {
		    $errno = mysql_errno($link);
		    $errmsg = mysql_error($link);
		    mysql_close($link);
		    error_page("err=" . $errno . " " . $errmsg
			       . " \nquery='$query'");
		    return;
		}
	    }
	    $query = "INSERT INTO users "
		. "(mail, passwd, graduate, name, kana, message, events) "
		. "VALUES ('"
		. mysql_escape_string($mail) . "', '$passwd', "
		. "$graduate, '"
		. mysql_escape_string($name) . "', '"
		. mysql_escape_string($kana) . "', '"
		. mysql_escape_string($message) . "', '"
		. mysql_escape_string($events) . "')";
	}
    }
    if (!isset($query)) {
	$query = "INSERT INTO users (mail, passwd) VALUES ('"
	    . mysql_escape_string($mail) . "', '$passwd')";
    }
    $result = mysql_query($query, $link);
    if ($result === FALSE) {
	$errno = mysql_errno($link);
	$errmsg = mysql_error($link);
	mysql_close($link);
	if ($errno == 1062) {	// Duplicate entry
	    resend($mail);
	    return;
	}
	error_page("err=" . $errno . " " . $errmsg
		   . " \nquery='$query'");
	return;
    }
    db_stat($link, 0);
    mysql_close($link);
    send_register_mail($mail, $passwd);
}

function resend($mail) {
    global $MyURL;
    $link = db_connect();
    if (!$link) {
	error_page("Could not connect to DB");
	return;
    }
    $query = "SELECT passwd FROM users WHERE "
	. "mail='" . mysql_escape_string($mail) . "'";
    $result = mysql_query($query, $link);
    if ($result === FALSE) {
	$errno = mysql_errno($link);
	$errmsg = mysql_error($link);
	mysql_close($link);
	error_page("err=" . $errno . " " . $errmsg
		   . " \nquery='$query'");
	return;
    }
    mysql_close($link);
    if ($line = mysql_fetch_row($result)) {
	$passwd = $line[0];
	send_register_mail($mail, $passwd);
    }
}

function send_register_mail($mail, $passwd) {
    global $MyURL;
    global $MailDomain;
    $body = "同窓会事務局です。
同窓会データベースのご利用ありがとうございます。
以下の URL をクリックして、
同窓会データベースへアクセスしてください。

${MyURL}?m=$mail&p=$passwd

この URL は、同窓会データベースへアクセスするための
パスワードを含んでいます。第三者に漏洩しないよう
注意してください。
";
    $err = send_mail($mail, '同窓会データベースURL', $body);
    if (is_a($err, PEAR_Error)) {
	error_page("err=" . $err->getCode()
		   . "\n" . $err->getMessage());
	return;
    }
    page_header();
?>
<p>
URL を書いたメールを <?php echo htmlspecialchars($mail, ENT_QUOTES); ?> 宛に、
<?php echo $MailDomain; ?> から送信しました。
メールが届きましたら、
メール本文中に書いてある URL をクリックして、
同窓会データベースへアクセスしてください。
</p>
<form action="<?php echo $MyURL; ?>" method="post">
<input type="hidden" name="n"
       value="<?php echo htmlspecialchars($mail, ENT_QUOTES); ?>">
<p>
もし、しばらく待ってもメールが届かない場合は、
メールアドレス <?php echo htmlspecialchars($mail, ENT_QUOTES); ?> が正しいか、
あるいはこのメールアドレスが携帯電話メールのアドレスの場合は、
<?php echo $MailDomain; ?> からのメールを受信できる設定になっているか
(迷惑メール対策として、
特定のドメイン以外からのメールを受信拒否している可能性があります)
ご確認の上、
<input type="submit" name="do_resend" value="再送"> ← 
このボタンを押してください。
</p>
</form>
<?php
}

function send_mail($recpt, $subject, $body) {
    global $MailHost;
    global $MailDomain;
    global $Office;
    $headers['From'] = $Office;
    $headers['To'] = $recpt;
    $headers['Subject'] = mb_encode_mimeheader($subject);
    $params['host'] = $MailHost;
    $params['localhost'] = $MailDomain;
    require_once 'Mail.php';
    $mail =& Mail::factory('smtp', $params);
    if (is_a($mail, PEAR_Error)) {
	$err =& $mail;
    } else {
	$err = $mail->send($recpt, $headers,
			   mb_convert_encoding($body, "JIS"));
    }
    return $err;
}

function newname($mail, $passwd, $graduate, $name, $kana) {
    global $MailDomain;
    if ($name == "") {
	new_user_page($mail, $passwd, '<font color="red">お名前を入力してください</font>');
	return;
    }
    $name = mb_convert_encoding($name, mb_internal_encoding(), "auto");
    $kana = mb_convert_encoding($kana, mb_internal_encoding(), "auto");
    if ($graduate != "" && !ctype_digit($graduate)) {
	new_user_page($mail, $passwd, '<font color="red">卒業期は半角数字で入力してください</font>');
	return;
    }
    $link = db_connect();
    if (!$link) {
	error_page("Could not connect to DB");
	return;
    }
    $query = "UPDATE users set name='" . mysql_escape_string($name) . "'";
    $query .= ", type=0, start=NOW()";
    if ($graduate != "" && ctype_digit($graduate)) {
	$query .= ", graduate=$graduate";
    }
    if ($kana != "") {
	$query .= ", kana='" . mysql_escape_string($kana) . "'";
    }
    $query .= " WHERE mail='" . mysql_escape_string($mail) . "'";
    if ($passwd !== TRUE) {
	$query .= " AND passwd='" . mysql_escape_string($passwd) . "'";
    }
    $result = mysql_query($query, $link);
    if ($result === FALSE) {
	$errno = mysql_errno($link);
	$errmsg = mysql_error($link);
	mysql_close($link);
	error_page("err=" . $errno . " " . $errmsg
		   . " \nquery='$query'");
	return;
    }
    send_mail("manager@$MailDomain", "新規登録",
	      "Mail: $mail\nふりがな: $kana\n名前: $name\n"
	      . "卒業: $graduate 期\n");
    registered_user_page($mail, $passwd,
    			 $graduate, $name, $kana, '', '',
			 $link, '');
    db_stat($link, 1);
    mysql_close($link);
}

function delete($mail, $passwd) {
    global $MailDomain;
    $link = db_connect();
    if (!$link) {
	error_page("Could not connect to DB");
	return;
    }
    $query = "DELETE FROM users WHERE "
	. "mail='" . mysql_escape_string($mail) . "'";
    if ($passwd !== TRUE) {
	$query .= " AND passwd='" . mysql_escape_string($passwd) . "'";
    }
    $result = mysql_query($query, $link);
    if ($result === FALSE) {
	$errno = mysql_errno($link);
	$errmsg = mysql_error($link);
	mysql_close($link);
	error_page("err=" . $errno . " " . $errmsg
		   . " \nquery='$query'");
	return;
    }
    mysql_close($link);
    $past = time() - 60;
    setcookie("mail", '', $past);
    setcookie("name", '', $past);
    setcookie("time", '', $past);
    setcookie("checksum", '', $past);
    send_mail("manager@$MailDomain", "登録削除", "Mail: $mail\n");
    top_page("メールアドレス $mail を削除しました。");
}

function correct($mail, $passwd,
		 $graduate, $name, $kana, $attend, $message) {
    global $MailDomain;
    if ($name == "") {
	$mesg = '<font color="red">お名前を入力してください</font><br />';
    }
    $name = mb_convert_encoding($name, mb_internal_encoding(), "auto");
    $kana = mb_convert_encoding($kana, mb_internal_encoding(), "auto");
    $message = mb_convert_encoding($message, mb_internal_encoding(), "auto");
    if ($graduate != "" && !ctype_digit($graduate)) {
	$mesg .= '<font color="red">卒業期は半角数字で入力してください</font><br />';
    }
    $attend = attend_bin($attend);
    $link = db_connect();
    if (!$link) {
	error_page("Could not connect to DB");
	return;
    }
    if ($mesg != "") {
	registered_user_page($mail, $passwd,
			     $graduate, $name, $kana, $attend, $message,
			     $link, $mesg);
	return;
    }
    $query = "UPDATE users set name='" . mysql_escape_string($name) . "'";
    if ($graduate != "" && ctype_digit($graduate)) {
	$query .= ", graduate=$graduate";
    }
    if ($kana != "") {
	$query .= ", kana='" . mysql_escape_string($kana) . "'";
    }
    $query .= ", events='" . mysql_escape_string($attend) . "'";
    $query .= ", message='" . mysql_escape_string($message) . "'";
    $query .= " WHERE mail='" . mysql_escape_string($mail) . "'";
    if ($passwd !== TRUE) {
	$query .= " AND passwd='" . mysql_escape_string($passwd) . "'";
    }
    $result = mysql_query($query, $link);
    if ($result === FALSE) {
	$errno = mysql_errno($link);
	$errmsg = mysql_error($link);
	mysql_close($link);
	error_page("err=" . $errno . " " . $errmsg
		   . " \nquery='$query'");
	return;
    }
    db_stat($link, 2);
    mysql_close($link);
    send_mail("manager@$MailDomain", "登録修正",
	      "Mail: $mail\nふりがな: $kana\n名前: $name\n"
	      . "卒業: $graduate 期\n"
	      . "出欠: " . bin2hex($attend) . "\n"
	      . "メッセージ:\n$message\n");
    user_page($mail, $passwd, '');
}

function user_page($mail, $passwd, $mesg) {
    global $Seed;
    global $PV;
    $link = db_connect();
    if (!$link) {
	error_page("Could not connect to DB");
	return;
    }
    $query = "SELECT graduate, name, kana, start, type, events, message "
    	. "FROM users WHERE "
	. "mail='" . mysql_escape_string($mail) . "'";
    if ($passwd !== TRUE) {
	$query .= " AND passwd='" . mysql_escape_string($passwd) . "'";
    }
    $result = mysql_query($query, $link);
    if ($result === FALSE) {
	$errno = mysql_errno($link);
	$errmsg = mysql_error($link);
	mysql_close($link);
	error_page("err=" . $errno . " " . $errmsg
		   . " \nquery='$query'");
	return;
    }
    if ($line = mysql_fetch_row($result)) {
	$graduate = $line[0];
	if (isset($line[1])) {
	    $name = $line[1];
	}
	$kana = $line[2];
	$start = $line[3];
	$type = $line[4];
	$attend = $line[5];
	$message = $line[6];
	$now = time();
	$expire = $now + 30*24*60*60;
	setcookie("mail", $mail, $expire, "", $Domain);
	setcookie("name", $name, $expire, "", $Domain);
	setcookie("time", $now, $expire, "", $Domain);
	setcookie("checksum", hash("sha256", $mail . $Seed . $now),
		  $expire, "", $Domain);
	if (ctype_digit($type)) {
	    setcookie("type", $type, $expire, "", $Domain);
	}
	if (!isset($start) || is_null($type) || $type == 2) {
	    $update = "UPDATE users set start=NOW()";
	    if (is_null($type) || $type == 2) {	/* メール不達取消し */
		$update .= ", type=0";
	    }
	    $update .= " WHERE mail='" . mysql_escape_string($mail) . "'";
	    $result_update = mysql_query($update, $link);
	    if ($result === FALSE) {
		$errno = mysql_errno($link);
		$errmsg = mysql_error($link);
		mysql_close($link);
		error_page("err=" . $errno . " " . $errmsg
			   . " \nquery='$update'");
		return;
	    }
	    $mesg = "<p>\nメールアドレス $mail を登録しました。\n</p>\n";
	}
	if (isset($name)) {
	    registered_user_page($mail, $passwd,
				 $graduate, $name, $kana, $attend, $message,
				 $link, $mesg);
	} else {
	    new_user_page($mail, $passwd, $mesg);
	}
    } else {
	bad_URL_page();
    }
    db_stat($link, $PV % 3);
    mysql_close($link);
}

function new_user_page($mail, $passwd, $mesg) {
    global $MyURL;
    page_header();
    if ($mesg != "") {
	print "<p>\n$mesg\n</p>\n";
    }
?>
<p>
お名前と卒業期の登録をお願いします。
</p>
<form action="<?php echo $MyURL; ?>" method="post">
<?php
    if ($passwd !== TRUE) {
?>
<input type="hidden" name="m"
       value="<?php echo htmlspecialchars($mail, ENT_QUOTES); ?>">
<input type="hidden" name="p"
       value="<?php echo htmlspecialchars($passwd, ENT_QUOTES); ?>">
<?php
    }
?>
<table>
<tr>
<th>ふりがな:</th>
<td><input type="text" name="newkana" size=20><br /></td>
</tr>
<tr>
<th>お名前:</th>
<td><input type="text" name="newname" size=20> <font color="red">必須</font></td>
</tr>
<tr>
<th>卒業:</th>
<td><input type="text" name="newgraduate" size=3> 期 (半角数字)
<a href="year_table.html" onclick="window.open('year_table.html'); return false;">卒業年早見表</a></td>
</tr>
</table>
<input type="submit" name="do_newname" value="登録">
</form>
<?php
}

function registered_user_page($mail, $passwd,
			      $graduate, $name, $kana, $attend, $message,
			      $link, $mesg) {
    global $MyURL;
    global $MemcacheObj;
    global $PV;
    global $Events;
    if (!prepare_events($link, FALSE)) {
	return;
    }
    page_header();
    if ($mesg != "") {
	print "<p>\n$mesg\n</p>\n";
    } else {
	print "<p>\n" . htmlspecialchars($name, ENT_QUOTES)
	    . "様、いらっしゃいませ。\n";
	if ($PV != "") {
	    print "あなたは累計 $PV 人目の訪問者です。<br />\n";
	}
	$nusers = memcache_get($MemcacheObj, "alumni_nusers_0");
	if ($nusers != "") {
	    print "このデータベースには "
	    	. "$nusers 人のデータが登録されています。<br />\n";
	}
	$nusers = memcache_get($MemcacheObj, "alumni_nusers_1");
	if ($nusers != "") {
	    print "その中でこのデータベースにアクセスしたことがある人は "
		. "$nusers 人です。\n";
	}
	print "</p>\n";
    }
?>
<p>
登録データは以下の通りです:
</p>
<form action="<?php echo $MyURL; ?>" method="post">
<?php
    if ($passwd !== TRUE) {
?>
<input type="hidden" name="m"
       value="<?php echo htmlspecialchars($mail, ENT_QUOTES); ?>">
<input type="hidden" name="p"
       value="<?php echo htmlspecialchars($passwd, ENT_QUOTES); ?>">
<?php
    }
?>
<table>
<tr>
<th>メール:</th>
<td><?php echo htmlspecialchars($mail, ENT_QUOTES); ?></td>
</tr>
<tr>
<th>ふりがな:</th>
<td><input type="text" name="newkana" size=20
	   value="<?php echo htmlspecialchars($kana, ENT_QUOTES); ?>"></td>
</tr>
<tr>
<th>お名前:</th>
<td><input type="text" name="newname" size=20
           value="<?php echo htmlspecialchars($name, ENT_QUOTES); ?>"></td>
</tr>
<tr>
<th>卒業:</th>
<td><input type="text" name="newgraduate" size=3
	   value="<?php echo htmlspecialchars($graduate, ENT_QUOTES); ?>">期
(半角数字)
<a href="year_table.html" onclick="window.open('year_table.html'); return false;">卒業年早見表</a></td>
</tr>
<tr><th valign="top">出欠:</th><td>参加/不参加を選択してください:<br />
<table>
<?php
    foreach($Events as $key => $value) {
	$key2 = $key + 0x80;
	print "<tr>\n";
	print "<td><select name=\"attend[]\">\n";
	print "<option value=\"\">(未定)\n";
	print "<option value=\"$key\" ";
	if (strbin($attend, $key)) {
	    print "selected";
	}
	print ">参加\n";
	print "<option value=\"$key2\" ";
	if (strbin($attend, $key2)) {
	    print "selected";
	}
	print ">不参加\n";
	print "</select></td>";
	print "<td>$value->date($value->week)</td><td>$value->name</td>\n";
	if ($value->site != "") print "<td>於 $value->site</td>";
	print "</tr>\n";
    }
?>
</table></td>
</tr>
<tr>
<th></th>
<td>同窓生のみなさんへのメッセージをどうぞ:
</tr>
<tr>
<th></th>
<td><textarea name="message" cols=40 rows=5>
<?php echo htmlspecialchars($message, ENT_QUOTES); ?>
</textarea>
</td>
</tr>
</table>
<p>
登録データを更新する場合は、
上の入力欄を書き換えた上で、<br />
<input type="submit" name="do_correct" value="登録"> 
← このボタンを押してください。
</p>

<h3>参加予定者の一覧</h3>
<table>
<?php
    if ($passwd === TRUE) {
	$authstr = "";
    } else {
	$authstr = "&amp;m=$mail&amp;p=$passwd";
    }
    foreach($Events as $key => $value) {
	print "<tr><td>$value->date($value->week)</td>";
	print "<td><a href=\"$MyURL?do_list=$key$authstr\">"
	    . $value->name . "</a></td>";
	if ($value->site != "") print "<td>於 $value->site</td>";
	print "</tr>\n";
    }
?>
</table>

<h3>メールアドレスの変更</h3>
<p>
登録したメールアドレスの変更をご希望の場合は、
以下に新しいメールアドレスを入力して「変更」ボタンを押してください。
</p>
<p>
メールアドレス: <input type="text" name="modmail" size=20>
<input type="submit" name="do_modify" value="変更">
</p>
<p>
入力頂いた新しいメールアドレスに、メールをお送りします。
メールが届きましたら、
メール本文中の URL へ WWWブラウザを使ってアクセスしてください。
</p>

<h3>メールアドレスの追加</h3>
<p>
現在のアドレスを残したまま、別のアドレスを追加登録する場合は、
以下に新しいメールアドレスを入力して「追加」ボタンを押してください。
</p>
<p>
メールアドレス: <input type="text" name="addmail" size=20>
<input type="submit" name="do_add" value="追加">
</p>

<h3>メールアドレスの削除</h3>
<p>
<input type="submit" name="do_delete" value="削除"> ← このボタンを押すと、
現在のアドレス <?php echo htmlspecialchars($mail, ENT_QUOTES); ?> 
を削除します。
</p>

</form>
<?php
}

function list_page($mail, $passwd, $id) {
    global $Events;
    $link = db_connect();
    if (!$link) {
	error_page("Could not connect to DB");
	return;
    }
    if ($passwd !== TRUE) {
	$query = "SELECT * FROM users WHERE "
	    . "mail='" . mysql_escape_string($mail) . "'"
	    . " AND passwd='" . mysql_escape_string($passwd) . "'";
	$result = mysql_query($query, $link);
	if ($result === FALSE) {
	    $errno = mysql_errno($link);
	    $errmsg = mysql_error($link);
	    mysql_close($link);
	    error_page("err=" . $errno . " " . $errmsg
		       . " \nquery='$query'");
	    return;
	}
	if (!mysql_fetch_row($result)) {
	    bad_URL_page();
	    return;
	}
    }
    $query = "SELECT graduate, name, events, message FROM users"
	    . " WHERE events<>'' OR message<>''"
	    . " ORDER BY graduate, kana, name";
    $result = mysql_query($query, $link);
    if ($result === FALSE) {
	$errno = mysql_errno($link);
	$errmsg = mysql_error($link);
	mysql_close($link);
	error_page("err=" . $errno . " " . $errmsg
		   . " \nquery='$query'");
	return;
    }
    if (!prepare_events($link, TRUE)) return;
    page_header();
    print "<p>";
    if (ctype_digit($id)) {
	$value = $Events[$id];
	print "$value->date($value->week)に";
	if ($value->site != "") print $value->site . "にて";
	print "開催される" . $value->name
	    . "へ、以下の方々が出席を表明されています:\n</p>\n";
    } else {
	print "以下の方々が出席/欠席を表明されています:\n</p>\n";
	print "<table>\n";
	foreach($Events as $key => $value) {
	    print "<tr><td>$value->abbr:</td>";
	    print "<td>$value->date($value->week)</td>";
	    print "<td>$value->name</td>";
	    if ($value->site != "")
		print "<td>於 $value->site</td>";
	    print "</tr>\n";
	}
	print "</table>\n";
    }
    print "<table class=\"ruler\">\n";
    print "<tr><th>期</th><th width=\"88\">氏名</th>";
    if (ctype_digit($id)) {
	print "<th width=\"40\">出欠</th>";
    } else {
	print "<th width=\"40\">参加</th><th width=\"40\">欠席</th>";
    }
    print "<th>メッセージ</th></tr>\n";
    $nattend = 0;
    while ($line = mysql_fetch_row($result)) {
	$graduate = $line[0];
	$name = $line[1];
	$attend = $line[2];
	$message = $line[3];
	$flag = FALSE;
	$line = "<tr><td>$graduate</td><td>$name</td><td>";
	if (ctype_digit($id)) {
	    if (strbin($attend, $id)) {
		$line .= "出席";
		$nattend++;
		$flag = TRUE;
	    } elseif (strbin($attend, $id + 0x80)) {
		$line .= "欠席";
		if ($message != "") $flag = TRUE;
	    } else {
		$line .= "未定";
	    }
	} else {
	    $yes = attend_str(TRUE, $attend);
	    $no = attend_str(FALSE, $attend);
	    $line .= "$yes</td><td>$no";
	    if ($yes != "" || $no != "" || $message != "") $flag = TRUE;
	}
	if ($flag) {
	    print "$line</td><td>$message</td></tr>\n";
	}
    }
    print "</table>\n";
    if (ctype_digit($id)) {
	print "<p>\n" . date("n月j日現在")
	    . $nattend . "名の方々が出席を表明しています。\n</p>\n";
    }
?>
<p>
行けるかどうかまだ確定していない方も、
行ける確率のほうが高そうであれば、
とりあえず参加表明を出しておいて頂けると幸いです。
参加表明は直前まで取消し可能
(できれば一週間前くらいには参加人数を確定させたいですが)
ですので。
</p>
<?php
    mysql_close($link);
}

function bad_URL_page() {
    top_page("<font color=\"red\">URL に間違いがあります。ご確認の上、再度アクセスをお願いします。</font><br />あるいは<a href=\"/inquiry\">同窓会事務局へお問い合わせ</a>下さい。");
}

function top_page($mesg) {
    global $MailDomain;
    global $MyURL;
    page_header();
?>
<?php
    if ($mesg != "") {
	print "<p>\n$mesg\n</p>\n";
    } else {
?>
<p>
同窓生の皆様の、お名前、卒業年度、
およびメールアドレスを登録するためのデータベース(名簿)です。
出欠登録もこちらにお願いします。
</p>
<p>
ご登録頂いたデータは、第三者に漏れることのないよう厳重に管理し、
同窓会事務局の運営目的 (事務局が案内する同窓会の運営を含む) 
にのみ使用します。 
</p>
<?php
    }
?>
<p>
データベースに登録・修正を行なうには、
まず
ご自身のメールアドレスを以下に入力して「送信」ボタンを押してください。
</p>
<form action="<?php echo $MyURL; ?>" method="post">
<p>
メールアドレス: <input type="text" name="newmail" size=20>
<input type="submit" name="do_register" value="送信">
</p>
</form>
<p>
あるいは、
お手持ちの携帯電話 (あるいは PC) から、
<a href="mailto:db@<?php echo $MailDomain; ?>">db@<?php echo $MailDomain; ?></a> 
宛にメールを送ってくださっても結構です。
</p>
<p>
折り返しメールをお送りします。
メール本文中の URL をクリックして同窓会データベースページへアクセスしてください。
</p>
<?php
}

function error_page($mesg) {
    global $Office;
    header("HTTP/1.1 503 Service Unavailable");
    page_header();
?>
<p>
申し訳ありません。
ただいまメンテナンス中につき、ご利用頂けません。
時間をあけて再度アクセスをお願いします。
</p>
<p>
もし既に何度かアクセスしていて、
いずれもこの「メンテナンス中」が表示される場合は、
同窓会事務局 <?php echo $Office; ?> 
宛にメールでお問い合わせ頂けますと幸いです。
</p>
<p>
メールでお問い合わせ頂く際は、
以下に表示される文字列をメールに張付けてお送り頂けますと、
大変助かります。
</p>
<hr />
<pre>
<?php print $mesg; ?>
</pre>
<?php
}

function page_header() {
    global $HeaderFlag;
    global $CharSet;
    if (!$HeaderFlag) {
	$HeaderFlag = TRUE;
?>
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $CharSet; ?>">
<link rel="stylesheet" href="/alumni.css" type="text/css" />
<title>Alumni Database</title>
</head>
<body>
<h1><a href="/">同窓会</a></h1>
<h2><a name="DB">同窓会データベース</a></h2>
<?php
    }
}

function attend_bin($array) {
    foreach(array_unique($array) as $value) {
	if (is_int($value) || ctype_digit($value)) $bin .= chr($value);
    }
    return $bin;
}

function attend_str($flag, $str) {
    global $Events;
    $array = unpack("C*", $str);
    if ($flag) {
	foreach($array as $value) {
	    if ($value < 0x80) $ret .= $Events[$value]->abbr;
	}
    } else {
	foreach($array as $value) {
	    if ($value >= 0x80) $ret .= $Events[$value & 0x7F]->abbr;
	}
    }
    return $ret;
}

function strbin($str, $bin) {
    $array = unpack("C*", $str);
    foreach($array as $value) {
	if ($value == $bin) return TRUE;
    }
    return FALSE;
}

function db_stat($link, $range) {
    global $MemcacheObj;
    if ($range == 1) {
	$query = "SELECT count(*) FROM users WHERE start IS NOT NULL";
    } elseif ($range == 2) {
	$query = "SELECT count(*) FROM users WHERE events IS NOT NULL";
    } else {
	$query = "SELECT count(*) FROM users";
    }
    $result = mysql_query($query, $link);
    if ($result === FALSE) {
	$errno = mysql_errno($link);
	$errmsg = mysql_error($link);
	error_page("err=" . $errno . " " . $errmsg
		   . " \nquery='$update'");
	return;
    }
    if ($line = mysql_fetch_row($result)) {
	$count = $line[0];
	memcache_set($MemcacheObj, "alumni_nusers_$range", $count);
    }
}

/*
  For Gnu Emacs.
  Local Variables:
  mode: php
  c-basic-offset: 4
  End:
*/
?>
