<?php
class Event {
    public $name;
    public $abbr;
    public $date;
    public $week;
    public $time;
    public $site;
    function __construct($name, $abbr, $date, $week, $time, $site) {
	$this->name = $name;
	$this->abbr = $abbr;
	$this->date = $date;
	$this->week = $week;
	$this->time = $time;
	$this->site = $site;
    }
}

$Events = NULL;
$Week2name = array('日', '月', '火', '水', '木', '金', '土');

function prepare_events($link, $allflag) {
    global $Events;
    global $Week2name;
    global $MemcacheObj;
    if (is_array($Events)) return $Events;
    $key = "alumni_events";
    if ($allflag) $key .= "_all";
    $Events = memcache_get($MemcacheObj, $key);
    if (is_array($Events)) return $Events;
    $Events = array();
    $query = "SELECT id, name, abbr,"
	. 'DATE_FORMAT(date,"%Y年%m月%d日"), DATE_FORMAT(date,"%w"), '
	. "start, end, site FROM events";
    if (!$allflag) $query .= " WHERE date >= CURDATE()";
    $query .= " ORDER BY date";
    if (!is_resource($link)) {
	$link = call_user_func($link);
	if (!$link) return FALSE;
    }
    $result = mysql_query($query, $link);
    if ($result === FALSE) {
#	$errno = mysql_errno($link);
#	$errmsg = mysql_error($link);
	mysql_close($link);
#	error_page("err=" . $errno . " " . $errmsg
#		   . " \nquery='$query'");
	return FALSE;
    }
    while ($line = mysql_fetch_row($result)) {
	$id = $line[0];
	$name = $line[1];
	$abbr = $line[2];
	$date = $line[3];
	$week = $Week2name[$line[4]];
	$time = $line[5];
	$site = $line[7];
	$Events[$id] = new Event($name, $abbr, $date, $week, $time, $site);
    }
    memcache_set($MemcacheObj, $key, $Events, 0, 30);
    return $Events;
}

/*
  For Gnu Emacs.
  Local Variables:
  mode: php
  c-basic-offset: 4
  End:
*/
?>
