<?php
$Debug = $_REQUEST['debug'];
require 'include/common.php';
$PV = memcache_get($MemcacheObj, "alumni_pv_index");
memcache_set($MemcacheObj, "alumni_pv_index", ++$PV);
require 'include/events.php';
?>
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $CharSet; ?>">
<link rel="stylesheet" href="/alumni.css" type="text/css" />
<title>同窓会のページ</title>
</head>

<body>
<h1>同窓会</h1>
<p>
<a href="/db">データベース</a> 　
<a href="#LINK">リンク</a> 　
<a href="/inquiry">お問合せ</a> 　
<?php
if (isset($_COOKIE['type']) == 1) {
?>
<a href="/manager.php">幹事専用</a> 　
<?php
}
?>
</p>

<?php
$pclause = FALSE;
if ($Authorized) {
    if (isset($_COOKIE['name'])) {
	$name = $_COOKIE['name'];
	print "<p>\n" . htmlspecialchars($name, ENT_QUOTES)
	    . "様、いらっしゃいませ。\n";
	$pclause = TRUE;
    }
}
if ($PV != "") {
    if (!$pclause) {
	print "<p>\n";
    }
    print "あなたは累計 $PV 人目の訪問者です。\n";
    $pclause = TRUE;
}
if ($pclause) {
    print "</p>\n";
}
?>

<h2>お知らせ</h2>


<hr />

<h2><a name="DB">同窓会データベース</a></h2>
<p>
同窓生の皆様の、お名前、卒業年度、
およびメールアドレスを登録するためのデータベース(名簿)です。
出欠登録もこちらにお願いします。
</p>
<p>
ご登録頂いたデータは、第三者に漏れることのないよう厳重に管理し、
同窓会事務局の運営目的 (事務局が案内する同窓会の運営を含む) 
にのみ使用します。 
</p>
<?php
if ($Authorized && prepare_events('db_connect')) {
    print "<p>\n<a href=\"/db\">登録データの修正および出欠登録</a>\n</p>\n";
    foreach($Events as $key => $value) {
	print "<p>\n$value->name ";
	if ($value->date != "") {
	    print "($value->date";
	    if ($value->site != "") print " 於 $value->site";
	    print ") ";
	}
	print "<a href=\"/db?do_list=$key\">参加予定者の一覧</a>\n</p>\n";
    }
} else {
?>
<p>
登録・修正を行なうには、
まず
ご自身のメールアドレスを以下に入力して「送信」ボタンを押してください。
</p>
<form action="/db" method="post">
<p>
メールアドレス: <input type="text" name="newmail" size=20>
<input type="submit" name="do_register" value="送信">
</p>
</form>
<p>
あるいは、
お手持ちの携帯電話 (あるいは PC) から、
<a href="mailto:<?php echo "db@$MailDomain"; ?>"><?php echo "db@$MailDomain"; ?></a> 
宛にメールを送ってくださっても結構です。
</p>
<p>
折り返しメールをお送りします。
メール本文中の URL をクリックして同窓会データベースページへアクセスしてください。
</p>
<?php
}
?>

</body>

<?php
/*
  For Gnu Emacs.
  Local Variables:
  mode: php
  c-basic-offset: 4
  End:
*/
?>
