<?php
$Domain = strtolower($_SERVER['SERVER_NAME']);
$MailDomain = preg_replace('/^www\./', '', $Domain);
$MyURL = "http://$Domain" . $_SERVER['REQUEST_URI'];
$Office = "office@$MailDomain";
$MailHost = "localhost";
$MemcacheObj = memcache_connect('localhost', 11211);
$PV = memcache_get($MemcacheObj, "alumni_pv_inquiry");
memcache_set($MemcacheObj, "alumni_pv_inquiry", ++$PV);

$CharSet = "Shift_JIS";
mb_http_output('SJIS');
ob_start('mb_output_handler');
?>
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $CharSet; ?>">
<link rel="stylesheet" href="/alumni.css" type="text/css" />
<title>同窓会のページ</title>
</head>

<body>
<h1><a href="/">同窓会</a></h1>
<?php
if (isset($_REQUEST['do_send'])) {
    $body = "名前　: " . $_REQUEST['name'] . "\n"
	  . "メール: " . $_REQUEST['mail'] . "\n"
	  . "接続元: " . $_SERVER['REMOTE_ADDR'] . ":"
		       . $_SERVER['REMOTE_PORT'] . " "
		       . $_SERVER['REMOTE_HOST'] . "\n"
	  . "端末　: " . $_SERVER['HTTP_USER_AGENT'] . "\n"
	  . "参照元: " . $_REQUEST['referer'] . "\n"
	  . "\n"
	  . mb_convert_encoding($_REQUEST['message'],
				mb_internal_encoding(), "auto");
    send_mail($Office, "同窓会ページからの問合せ", $body);
?>
<p>
お問合せありがとうございました。
</p>
<p>
<a href="/">同窓会のページに戻る</a>。
</p>
<?php
} else {
?>
<h2>お問合せ</h2>
<p>
<a href="/">本サイト</a>は、
同窓会事務局が運営しています。<br />
なにかお気付きの点などありましたら、
以下にご入力下さい。
</p>
<form action="<?php echo $MyURL; ?>" method="post">
<p>
お名前: <input type="text" name="name" size=30>
</p>
<p>
メールアドレス: <input type="text" name="mail" size=50><br />
回答はご入力頂いたメールアドレスへ送信いたします。
</p>
<p>
お問い合わせ内容をご入力下さい:<br />
<textarea name="message" cols=70 rows=10>
</textarea><br />
ご面倒でなければ、卒業年、最終クラス名、担任名などを入力頂けますと、
事務局にて確認できますので助かります。
</p>
<p>
<input type="hidden" name="referer"
       value="<?php echo $_SERVER['HTTP_REFERER']; ?>">
<input type="submit" name="do_send" value="送信"> 
← このボタンを押すと同窓会事務局へ、
メール送信します。
</p>
</form>
<?php
}
?>
</body>
<?php

function send_mail($recpt, $subject, $body) {
    global $MailHost;
    global $MailDomain;
    global $Office;
    $headers['From'] = $Office;
    $headers['To'] = $recpt;
    $headers['Subject'] = mb_encode_mimeheader($subject);
    $params['host'] = $MailHost;
    $params['localhost'] = $MailDomain;
    require_once 'Mail.php';
    $mail =& Mail::factory('smtp', $params);
    if (is_a($mail, PEAR_Error)) {
	$err =& $mail;
    } else {
	$err = $mail->send($recpt, $headers,
			   mb_convert_encoding($body, "JIS", "auto"));
    }
    return $err;
}
