<?php
$Debug = $_REQUEST['debug'];
require 'include/common.php';
$PV = memcache_get($MemcacheObj, "alumni_pv_manager");
memcache_set($MemcacheObj, "alumni_pv_manager", ++$PV);
require 'include/events.php';
$HeaderFlag = FALSE;
$DBLink = db_connect();
if (!$DBLink) {
    error_page("Could not connect to DB");
    exit();
}
if (!prepare_events($DBLink, TRUE)) {
    exit();
}
$query = "SELECT graduate, name, type FROM users WHERE type=1 AND "
	. "mail='" . mysql_escape_string($Mail) . "'";
if ($Passwd !== TRUE) {
    $query .= " AND passwd='" . mysql_escape_string($Passwd) . "'";
}
$result = mysql_query($query, $DBLink);
if ($line = mysql_fetch_row($result)) {
    $Graduate = $line[0];
    $Name = $line[1];
    $Type = $line[2];
    $now = time();
    $expire = $now + 30*24*60*60;
    setcookie("mail", $Mail, $expire, "", $Domain);
    setcookie("name", $Name, $expire, "", $Domain);
    setcookie("time", $now, $expire, "", $Domain);
    setcookie("checksum", hash("sha256", $Mail . $Seed . $now),
		  $expire, "", $Domain);
    setcookie("type", $Type, $expire, "", $Domain);
    foreach($Events as $key => $value) {
	$req = $_REQUEST["attend$key"];
	if (isset($req)) {
	    if ($req == 0) $AttendAst[] = $key;
	    elseif ($req == 1) $AttendAst[] = $key+0x80;
	    elseif ($req == 2) $AttendNeg[] = $key;
	}
    }
    if (isset($_REQUEST['do_dry_send'])) {
	do_send_mail($_REQUEST['recipient'], $_REQUEST['graduates'],
		     $_REQUEST['subject'], $_REQUEST['message'], TRUE);
    } elseif (isset($_REQUEST['do_send'])) {
	do_send_mail($_REQUEST['recipient'], $_REQUEST['graduates'],
		     $_REQUEST['subject'], $_REQUEST['message'], FALSE);
    } elseif (isset($_REQUEST['do_invite_send'])) {
	do_invite_send($_REQUEST['newmail'], $_REQUEST['newgraduate'],
		       $_REQUEST['newname'], $_REQUEST['subject'],
		       $_REQUEST['message']);
    } elseif (isset($_REQUEST['do_invite'])) {
	invite_page('');
    } else {
	send_mail_page('');
    }
} else {
    sorry_page();
}
page_header();
?>
<p>
<a href="/">同窓会のページ</a> に戻る。
</p>
</body>
</html>

<?php
function do_send_mail($rcpt, $graduates, $subject, $message, $dryrun) {
    global $Domain;
    global $MyURL;
    global $MailDomain;
    global $Mail;
    global $DBLink;
    global $AttendAst;
    global $AttendNeg;
    global $Debug;
    $subject = mb_convert_encoding($subject, mb_internal_encoding(), "auto");
    $message = mb_convert_encoding($message, mb_internal_encoding(), "auto");
    if (!$dryrun && $rcpt != "self") {
	$body = "Sender: $Mail\nRcpt: $rcpt ($graduates)\n"
		. "Assert: " . bin2hex(attend_bin($AttendAst)) . "\n"
		. "Negate: " . bin2hex(attend_bin($AttendNeg)) . "\n"
		. "\n$message";
	send_mail("manager@$MailDomain", $subject, $body);
    }
    $query = "SELECT graduate, name, mail, passwd, events FROM users";
    $query .= " WHERE type <> 2";
    $or = "AND (";
    if ($graduates != ""
        && preg_match('/^\d*(-\d*)?(,\d*(-\d*)?)*$/', $graduates)) {
	$parts = split(",", $graduates);
	while (list($key, $val) = each($parts)) {
	    if (preg_match('/^-(\d+)$/', $val, $matches)) {
		$query .= " $or graduate <= " . $matches[1];
	    } elseif (ctype_digit($val)) {
		$query .= " $or graduate = $val";
	    } elseif (preg_match('/^(\d+)-(\d*)$/', $val, $matches)) {
		$query .= " $or graduate >= " . $matches[1];
		if (ctype_digit($matches[2])) {
		    $query .= " AND graduate <= " . $matches[2];
		}
	    }
	    $or = "OR";
	}
	if ($or == "OR") {
	    $query .= " )";
	}
    }
    if ($rcpt == "self") {
	$query .= " AND mail='" . mysql_escape_string($Mail) . "'";
    } elseif ($rcpt == "manager") {
	$query .= " AND type=1";
    } elseif ($rcpt == "active") {
	$query .= " AND start IS NOT NULL";
    } elseif ($rcpt == "inactive") {
	$query .= " AND start IS NULL";
    } elseif ($rcpt == "all") {
    }
    $query .= " ORDER BY graduate, kana, name";
    $result = mysql_query($query, $DBLink);
    if ($result === FALSE) {
	$errno = mysql_errno($DBLink);
	$errmsg = mysql_error($DBLink);
	mysql_close($DBLink);
	error_page("err=" . $errno . " " . $errmsg
		   . " \nquery='$query'");
	return;
    }
    page_header();
    if ($Debug) {
	print "<pre>\nquery: $query\n</pre>\n";
    }
?>
<h3>同窓生へのメール一斉送信</h3>
<p>
以下の送信先アドレスに対し、メールを送信します。
</p>
<table class="ruler">
<tr><th>期</th><th>氏名</th><th>送信先アドレス</th>
<?php
    if (!$dryrun) {
	print "<th>送信結果</th>";
    }
    print "</tr>\n";
    $nsuccess = 0;
    $nfailure = 0;
    while ($line = mysql_fetch_row($result)) {
	$graduate = $line[0];
	$name = $line[1];
	$mail = $line[2];
	$passwd = $line[3];
	$attend = unpack("C*", $line[4]);
	if (is_array($AttendAst)) {
	    foreach($AttendAst as $value) {
		if (array_search($value, $attend) === FALSE) continue 2;
	    }
	}
	if (is_array($AttendNeg)) {
	    foreach($AttendNeg as $value) {
		if (array_search($value, $attend) !== FALSE) continue 2;
		if (array_search($value+0x80, $attend) !== FALSE) continue 2;
	    }
	}
	$src = array("%%YEAR%%", "%%NAME%%", "%%DBURL%%");
	$dst = array($graduate, $name, "http://$Domain/db?m=$mail&p=$passwd");
	$body = str_replace($src, $dst, $message);
	$mailomit = preg_replace('/(\@[^\.]+)\..*/', "$1...", $mail);
	print "<tr><td>$graduate</td><td>$name</td><td>$mailomit</td>\n";
	if ($dryrun) {
	    $nsuccess++;
	} else {
	    $err = send_mail($mail, $subject, $body);
	    if (is_a($err, PEAR_Error)) {
		print "<td>" . $err->getMessage()
		    . " err=" . $err->getCode() . "</td>\n";
		$nfailure++;
	    } else {
		print "<td>成功</td>";
		$nsuccess++;
	    }
	}
	print "</tr>\n";
    }
    $src = array("&", "<", ">");
    $dst = array("&amp;", "&lt;", "&gt;");
    $body = str_replace($src, $dst, $body);
?>
</table>
<?php
    if ($dryrun) {
	print "<p>$nsuccess 通が送信対象となります。</p>\n";
    } else {
	print "<p>$nsuccess 通の送信に成功し、"
	    . "$nfailure 通の送信に失敗しました。</p>\n";
    }
    if ($Debug) {
?>
<p>
最後の送信先アドレスに送られるメール本文を、以下に引用します。
</p>
<hr />
<pre>
<?php echo "Subject: $subject\n\n$body"; ?>
</pre>
<hr />
<?php
    }
?>
<p>
<a href="<?php echo $MyURL; ?>">役員・幹事 専用ページ</a> に戻る。
</p>
<?php
}

function send_mail_page($mesg) {
    global $Domain;
    global $MyURL;
    global $MemcacheObj;
    global $Name;
    global $Mail;
    global $PV;
    global $Events;
    page_header();
    if ($mesg != "") {
	print "<p>\n$mesg\n</p>\n";
    } else {
	print "<p>\n" . htmlspecialchars($Name, ENT_QUOTES)
	    . "様、いらっしゃいませ。\n";
	if ($PV != "") {
	    print "あなたは累計 $PV 人目の訪問者です。<br />\n";
	}
	$nusers = memcache_get($MemcacheObj, "alumni_nusers_0");
	if ($nusers != "") {
	    print "同窓会データベースには "
	    	. "$nusers 人のデータが登録されています。<br />\n";
	}
	$nusers = memcache_get($MemcacheObj, "alumni_nusers_1");
	if ($nusers != "") {
	    print "その中でこのデータベースにアクセスしたことがある人は "
		. "$nusers 人です。\n";
	}
	print "</p>\n";
    }
?>
<h3><a href="<?php echo $MyURL; ?>?do_invite=">同窓生への勧誘メール送信</a></h3>
<p>
メールアドレスが判明しているが、
まだデータベースに登録されていない同窓生に対し、
勧誘メールを送ることができます。
</p>

<h3>同窓生へのメール一斉送信</h3>
<form action="<?php echo $MyURL; ?>" method="post">
<p>
送信対象として、「役員・幹事のみ」 や
「イベントへの参加/欠席表明をまだ行なっていない人」
などを指定することができます。
</p>
<p>
送信対象を、特定のイベントの出席者あるいは欠席者に限定したい場合は、
当該イベントの 出 (出席), 欠 (欠席), 未 (未定, 出欠を表明していない人) 
の欄をクリックしてください。
無 (無指定) の欄は限定しない場合です。
</p>
<table class="ruler">
<tr>
<td>出</td><td>欠</td><td>未</td><td>無</td>
<th>イベント名</th><th>日付</th>
</tr>
<?php
    foreach($Events as $key => $value) {
	print "<tr>";
	print '<td><input type="radio" name="attend'
	. $key . '" value=0></td>';
	print '<td><input type="radio" name="attend'
	. $key . '" value=1></td>';
	print '<td><input type="radio" name="attend'
	. $key . '" value=2></td>';
	print '<td><input type="radio" name="attend'
	. $key . '" value=3 checked></td>';
	print "<td>$value->name</td>";
	print "<td>$value->date($value->week)</td>";
	print "</tr>\n";
    }
?>
</table>
<p>
送信対象を特定の卒業「期」 の同窓生に限定したい場合は、
「範囲指定」 の欄に 「期」 の数字をカンマ区切りで入力してください。
</p>
<p>
以下の 「送信先」 を選択し、 「確認」 ボタンを押すと、
送信対象となるアドレスの一覧を表示します。
「送信先」 として 「自身」 を選ぶと、
自分 (<?php echo $Mail; ?>) だけに送信して送信動作を確認することができます。
</p>
<p>
「期」の範囲指定: <input type="text" name="graduates"> 　 
送信先: <select name="recipient">
<option value="self" selected>自身
<option value="manager">役員・幹事
<option value="active">DB参照
<option value="inactive">DB未参照
<option value="all">全員
</select> 　 
<input type="submit" name="do_dry_send" value="確認"> 
</p>
<p>
以下に Subject: とメール本文を入力し、
「送信」ボタンを押すと一斉送信します。
「自身」以外に送信するときは、
充分に確認した上でボタンを押すようお願いします。
</p>
<p>
Subject: <input type="text" name="subject" size=60
          value="同窓会データベースへのご登録のお願い" />
</p>
<p>
本文:<br />
<textarea name="message" cols=70 rows=20>
%%YEAR%%期　%%NAME%%　様

同窓会事務局です。

同窓会では、同窓生の名前、卒業年度、およびメールアドレスを
登録するためのデータベース(名簿)を運用しています。

総会や同期会のお知らせ、および出欠の登録などに利用している
データベースですので、ぜひ %%NAME%% さまにもご登録頂きたく
メールをお送りした次第です。

登録方法は簡単で、次の URL をクリックするだけです。

%%DBURL%%

この URL は、同窓会データベースへアクセスするための
パスワードを含んでいます。第三者に漏洩しないよう
ご注意ください。
</textarea>
<p>
<input type="submit" name="do_send" value="送信"> 
← このボタンを押すとメールを一斉送信します。
</p>
</form>
<p>
送信に先だって、次の置換が行なわれます。
</p>
<table class="ruler">
<tr><th>置換対象</th><th>置換後</th></tr>
<tr><td>%%YEAR%%</td><td>卒業した「期」</td></tr>
<tr><td>%%NAME%%</td><td>氏名</td></tr>
<tr><td>%%DBURL%%</td><td>同窓会DB にアクセスする URL</td></tr>
</table>
<?php
}

function do_invite_send($mail, $graduate, $name, $subject, $message) {
    global $Domain;
    global $MyURL;
    global $MailDomain;
    global $Mail;
    global $DBLink;
    global $Debug;
    $name = mb_convert_encoding($name, mb_internal_encoding(), "auto");
    $subject = mb_convert_encoding($subject, mb_internal_encoding(), "auto");
    $message = mb_convert_encoding($message, mb_internal_encoding(), "auto");
    if (!check_mail($mail)) {
	$mesg .= '<font color="red">メールアドレスが不適切です</font><br />';
    }
    if ($name == "") {
	$mesg .= '<font color="red">お名前を入力してください</font><br />';
    }
    if (!ctype_digit($graduate)) {
	$mesg .= '<font color="red">卒業期は半角数字で入力してください</font><br />';
    }
    if ($mesg != "") {
	invite_page($mesg);
	return;
    }
    $passwd = mkpasswd();
    $query = "INSERT INTO users (mail, passwd, graduate, name, type) VALUES ('"
	. mysql_escape_string($mail) . "', '$passwd', $graduate, '"
	. mysql_escape_string($name) . "', 0)";
    $result = mysql_query($query, $DBLink);
    if ($result === FALSE) {
	$errno = mysql_errno($DBLink);
	$errmsg = mysql_error($DBLink);
	mysql_close($DBLink);
	if ($errno == 1062) {	// Duplicate entry
	    invite_page("<font color=\"red\">メールアドレス $mail は"
			. "既に登録済です</font><br />");
	    return;
	}
	error_page("err=" . $errno . " " . $errmsg
		   . " \nquery='$query'");
	return;
    }
    $src = array("%%YEAR%%", "%%NAME%%", "%%DBURL%%");
    $dst = array($graduate, $name, "http://$Domain/db?m=$mail&p=$passwd");
    $body = str_replace($src, $dst, $message);
    $err = send_mail($mail, $subject, $body);
    if (is_a($err, PEAR_Error)) {
	error_page("err=" . $err->getCode()
		   . "\n" . $err->getMessage());
	return;
    }
    $body = "Sender: $Mail\nRcpt: $mail\n"
	. "氏名: $name\n卒業: $graduate 期\n\n$message";
    send_mail("manager@$MailDomain", $subject, $body);
    page_header();
?>
<h3>同窓生への勧誘メール送信</h3>
<p>
<?php echo $mail; ?> 宛に勧誘メールを送信しました。
</p>
<p>
<a href="<?php echo $MyURL; ?>">役員・幹事 専用ページ</a> に戻る。
</p>
<?php
}

function invite_page($mesg) {
    global $Domain;
    global $MyURL;
    global $MemcacheObj;
    global $Graduate;
    global $Name;
    global $Mail;
    global $PV;
    page_header();
    if ($mesg != "") {
	print "<p>\n$mesg\n</p>\n";
    } else {
	print "<p>\n" . htmlspecialchars($Name, ENT_QUOTES)
	    . "様、いらっしゃいませ。\n";
	if ($PV != "") {
	    print "あなたは累計 $PV 人目の訪問者です。<br />\n";
	}
	$nusers = memcache_get($MemcacheObj, "alumni_nusers_0");
	if ($nusers != "") {
	    print "同窓会データベースには "
	    	. "$nusers 人のデータが登録されています。<br />\n";
	}
	$nusers = memcache_get($MemcacheObj, "alumni_nusers_1");
	if ($nusers != "") {
	    print "その中でこのデータベースにアクセスしたことがある人は "
		. "$nusers 人です。\n";
	}
	print "</p>\n";
    }
?>
<h3>同窓生への勧誘メール送信</h3>
<form action="<?php echo $MyURL; ?>" method="post">
<p>
メールアドレスが判明しているが、
まだデータベースに登録されていない同窓生に対し、
勧誘メールを送ることができます。
</p>
<p>
以下に、勧誘する同窓生の 「メールアドレス」 「氏名」 「期」 
および勧誘メールの 「Subject」 と 「本文」 を入力し、
送信ボタンを押してください。
</p>
<table>
<tr>
<th align="right">メールアドレス:</th>
<td><input type="text" name="newmail" size=40 /></td>
</tr><tr>
<th align="right">氏名:</th>
<td><input type="text" name="newname" size=20 /></td>
</tr><tr>
<th align="right">卒業:</th>
<td><input type="text" name="newgraduate" size=3 />期</td>
</tr><tr>
<th align="right">Subject:</th>
<td><input type="text" name="subject" size=60
     value="同窓会データベースへの登録のお願い" /></td>
</tr>
</table>
<p>
<b>本文:</b><br />
<textarea name="message" cols=70 rows=21>
%%YEAR%%期　%%NAME%%　さま

<?php echo htmlspecialchars($Name, ENT_QUOTES); ?> です。ご無沙汰しております。

同窓会 <?php echo $Graduate; ?>期の幹事を
担当しております。

同窓会では、同窓生の名前、卒業年度、およびメールアドレスを
登録するためのデータベース(名簿)を運用していまして、
総会や同期会のお知らせ、および出欠の登録などに利用しています。

ぜひ %%NAME%% さまにもご登録頂きたくメールをお送りした次第です。
登録方法は簡単で、次の URL をクリックするだけです。

%%DBURL%%

この URL は、同窓会データベースへアクセスするための
パスワードを含んでいます。第三者に漏洩しないよう
ご注意ください。
</textarea>
<p>
<input type="submit" name="do_invite_send" value="送信"> 
← このボタンを押すと勧誘メールを送信します。
</p>
</form>
<p>
送信に先だって、次の置換が行なわれます。
</p>
<table class="ruler">
<tr><th>置換対象</th><th>置換後</th></tr>
<tr><td>%%YEAR%%</td><td>卒業した「期」</td></tr>
<tr><td>%%NAME%%</td><td>氏名</td></tr>
<tr><td>%%DBURL%%</td><td>同窓会DB にアクセスする URL</td></tr>
</table>

<h3><a href="<?php echo $MyURL; ?>">同窓生へのメール一斉送信</a></h3>
<p>
送信対象として、「役員・幹事のみ」や
「参加/欠席表明をまだ行なっていない人」などを指定することができます。
</p>

<p>
<a href="<?php echo $MyURL; ?>">役員・幹事 専用ページ</a> に戻る。
</p>
<?php
}

function sorry_page() {
    page_header();
?>
<p>
申し訳ありません。
このページは同窓会の役員および幹事の専用ページであるため、
ご利用頂けません。
</p>
<p>
もしあなたが役員あるいは幹事である場合は、
このページを利用できるよう設定しますので、
<a href="/inquiry">同窓会事務局</a> までご連絡下さい。
</p>
<?php
}

function error_page($mesg) {
    global $Office;
    header("HTTP/1.1 503 Service Unavailable");
    page_header();
?>
<p>
申し訳ありません。
ただいまメンテナンス中につき、ご利用頂けません。
時間をあけて再度アクセスをお願いします。
</p>
<p>
もし既に何度かアクセスしていて、
いずれもこの「メンテナンス中」が表示される場合は、
同窓会事務局 <?php echo $Office; ?> 
宛にメールでお問い合わせ頂けますと幸いです。
</p>
<p>
メールでお問い合わせ頂く際は、
以下に表示される文字列をメールに張付けてお送り頂けますと、
大変助かります。
</p>
<hr />
<pre>
<?php print $mesg; ?>
</pre>
<?php
}

function page_header() {
    global $HeaderFlag;
    global $CharSet;
    if (!$HeaderFlag) {
	$HeaderFlag = TRUE;
?>
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $CharSet; ?>">
<link rel="stylesheet" href="/alumni.css" type="text/css" />
<title>Alumni Database</title>
</head>
<body>
<h1><a href="/">同窓会</a></h1>
<h2>役員・幹事 専用ページ</h2>
<?php
    }
}

function send_mail($recpt, $subject, $body) {
    global $MailHost;
    global $MailDomain;
    global $Office;
    $headers['From'] = $Office;
    $headers['To'] = $recpt;
    $headers['Subject'] = mb_encode_mimeheader($subject);
    $headers['MIME-Version'] = "1.0";
    $headers['Content-type'] = "text/plain; charset=ISO-2022-JP";
    $params['host'] = $MailHost;
    $params['localhost'] = $MailDomain;
    require_once 'Mail.php';
    $mail =& Mail::factory('smtp', $params);
    if (is_a($mail, PEAR_Error)) {
	$err =& $mail;
    } else {
	$err = $mail->send($recpt, $headers,
			   mb_convert_encoding($body, "JIS"));
    }
    return $err;
}

function attend_bin($array) {
    foreach(array_unique($array) as $value) {
	if (is_int($value) || ctype_digit($value)) $bin .= chr($value);
    }
    return $bin;
}

/*
  For Gnu Emacs.
  Local Variables:
  mode: php
  c-basic-offset: 4
  End:
*/
?>
